﻿Public Class drum
    Const PICT_NUM As Integer = 5    'drum一つに使うピクチャボックスの数（表示は上下１つずつ隠しておく）
    Const ICON_SIZE As Integer = 32
    Private bmps(PICT_NUM - 1) As Bitmap
    Private g(PICT_NUM - 1) As Graphics
    Public PicBoxes(PICT_NUM - 1) As PictureBox
    Private Icons(PICT_NUM - 1) As Icon
    '==========================================
    Private addvalue = 8        'ICON_SIZEの約数で
    Public StopFlg As Boolean = False
    '==========================================
    Public arrayIcons(PICT_NUM - 1) As Integer     '当たり判定用

    Private Sub drum_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'PictureBoxは上下１つずつ見えないようにしておく
        Me.PanelDrumDisplay.Size = New Size(ICON_SIZE + 16, ICON_SIZE * (PicBoxes.Length - 2) + 5)
        Me.PanelDrumDisplay.BorderStyle = Windows.Forms.BorderStyle.Fixed3D

        Call SetIcons()

        For i As Integer = 0 To PicBoxes.Length - 1
            bmps(i) = New Bitmap(ICON_SIZE + 16, ICON_SIZE)
            g(i) = Graphics.FromImage(bmps(i))
            g(i).DrawIcon(Icons(i), 5, 0)
            g(i).Dispose()

            PicBoxes(i) = New PictureBox
            With PicBoxes(i)
                .Size = New Size(ICON_SIZE + 16, ICON_SIZE)
                .Image = bmps(i)
                .Top = ICON_SIZE * (PicBoxes.Length - 2 - i)
                .Tag = arrayIcons(i)            '当たり判定用
            End With

            Me.PanelDrumDisplay.Controls.Add(PicBoxes(i))

        Next

    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static counter As Integer = 0
        Static ii As Integer = 0
        Dim picCounter(PICT_NUM - 1) As Integer
        Dim picCenter As Integer = Int(PICT_NUM / 2)

        If counter Mod (ICON_SIZE / addvalue) = 0 Then      'ドラムのPictureBoxを回転させるコア部分
            For j As Integer = 0 To PicBoxes.Length - 1
                PicBoxes(j).Top = ICON_SIZE * (PicBoxes.Length - 2 - j)
                picCounter(j) = (j + ii) Mod PicBoxes.Length
                PicBoxes(j).Image = bmps(picCounter(j))
                PicBoxes(j).Tag = arrayIcons(picCounter(j)) 'Imageの絵柄を覚えておく

            Next
            ii += 1

            '回転をゆっくり止める仕組み　一定の場所に止めるため記述はここ
            If StopFlg Then
                Me.Timer1.Interval += 250

                If Me.Timer1.Interval > 1000 Then
                    Me.Timer1.Enabled = False

                    PicBoxes(picCenter).BorderStyle = Windows.Forms.BorderStyle.FixedSingle

                    System.Media.SystemSounds.Asterisk.Play()

                End If
            End If

        Else
            For i As Integer = 0 To PicBoxes.Length - 1
                PicBoxes(i).Top += addvalue
            Next

        End If
        counter += 1

    End Sub
    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStop.Click
        System.Media.SystemSounds.Asterisk.Play()
        StopFlg = True
    End Sub

    Private Sub SetIcons()
        'リールのアイコン順をランダムにする
        '一旦使用するアイコンをセットし、当たり判定用の配列を同期させる
        Icons(0) = SystemIcons.Question
        Icons(1) = SystemIcons.Error
        Icons(2) = SystemIcons.Exclamation
        Icons(3) = SystemIcons.Information
        Icons(4) = SystemIcons.Shield

        For i As Integer = 0 To PICT_NUM - 1
            arrayIcons(i) = i
        Next

        Dim ico1 As Integer
        Dim ico2 As Integer
        Dim tempIcon As Icon
        Dim tempNumber As Integer

        Randomize()
        For i As Integer = 0 To 10
            ico1 = Int(Rnd() * PICT_NUM)
            tempIcon = Icons(ico1)
            tempNumber = arrayIcons(ico1)

            ico2 = Int(Rnd() * PICT_NUM)
            Icons(ico1) = Icons(ico2)
            arrayIcons(ico1) = arrayIcons(ico2)

            Icons(ico2) = tempIcon
            arrayIcons(ico2) = tempNumber
        Next

    End Sub

End Class
